
#
# 
#   ______                           __        ____    _      __  __     
#  / ___(_)__ ___ _  ___  ___ ____  / /__     / __/___(_)_ __/ /_/ /____ 
# / (_ / / _ `/  ' \/ _ \/ _ `/ _ \/ / _ \   _\ \/ __/ / // / __/ __/ _ \
# \___/_/\_,_/_/_/_/ .__/\_,_/\___/_/\___/  /___/\__/_/\_,_/\__/\__/\___/
#                 /_/                                                   
# http://www.giampaolo-sciutto.it/
#

# Name Script : ScriptRestoreCheckpointGS.ps1
# Descrizione : Restorizza un Checkpoint di Hyper-V desiderato
# 
# Versione    : 1.0
# Requisiti   : Import-Module Hyper-V
# Piattaforme Verificate : Windows 2012R2
#
# Modify by Giampaolo Sciutto
# Date Modify: 24/04/2016
#


# Nome della VM
$VirtualMachine = "CLIENT"
# Nome dell'Host Hyper-V
$HyperVHost = "HYPERVISOR"
# Nome del Checkpoint desiderato - utilizzare il comando Get-VMsnapshot VMname $VirtualMachine per la lista, se necessario
$RestoreCheckpoint = "NOME CHECKPOINT"

# Recuperare le informazioni della VM
$VM = Get-VM -ComputerName $HyperVHost -Name $VirtualMachine
# Spegnere la VM
IF ($VM.State -ne "Off") 
{
	Write-Host (Get-Date)": Shutdown $VirtualMachine"
	Stop-Computer -ComputerName $VirtualMachine -Force
}

# Attendere lo spegnimento della VM
Write-Host (Get-Date)": Waiting for $VirtualMachine to be Off"

While ((Get-VM -ComputerName $HyperVHost -Name $VirtualMachine).State -ne "Off")
{
	Write-Host "." -NoNewLine
	Start-Sleep -Seconds 5
}
Write-Host " "
Write-Host (Get-Date)": $VirtualMachine is in Off state"

# Risolvere i nomi degli Snapshot - Inutile se gi fatto
Get-VMsnapshot VMname $VirtualMachine

# Restorizza lo Snapshot desiderato
Restore-VMsnapshot -Name $RestoreCheckpoint -VMName $VirtualMachine -Confirm:$false

# Riaccendere la VM
Write-Host (Get-Date)": Starting $VirtualMachine"
Start-VM -ComputerName $HyperVHost -Name $VM.Name

#



